"use strict";

var clir = require("clir"),
    through = require("through2"),
    gutil = require("gulp-util");

var replaceExtension = gutil.replaceExtension,
    PluginError = gutil.PluginError;

module.exports = function () {
  var compile = function compile(file, enc, cb) {
    file.path = replaceExtension(file.path, ".c");

    if (file.isStream()) {
      cb(new PluginError("gulp-clir", "Streaming not supported"));
    }

    if (file.isBuffer()) {
      try {
        var contents = String(file.contents),
            compiled = clir.transform(contents);
        file.contents = new Buffer(compiled);
      } catch (error) {
        cb(new PluginError("gulp-jade", error));
      }
    }

    return cb(null, file);
  };

  return through.obj(compile);
};